package fr.unice.reneviergonin.demogesture;

import android.content.Context;
import android.support.v4.view.GestureDetectorCompat;
import android.view.GestureDetector;
import android.view.MotionEvent;
import android.view.View;

import fr.unice.reneviergonin.images.Squares;


public class GestureCommad implements GestureDetector.OnGestureListener,  GestureDetector.OnDoubleTapListener, View.OnTouchListener {

    private Squares controled;
    GestureDetectorCompat detector;

    public GestureCommad(Context c, View source, Squares controled) {
        detector = new GestureDetectorCompat(c,this);
        detector.setOnDoubleTapListener(this);
        // pas d'abonnement direct (c.f. l'activité)
        // source.setOnTouchListener(this);
        this.controled = controled;
    }

    @Override
    public boolean onDown(MotionEvent motionEvent) {
        return true;
    }

    @Override
    public void onShowPress(MotionEvent motionEvent) {
    }

    @Override
    public boolean onSingleTapUp(MotionEvent motionEvent) {
        controled.zoomIn();
        return true;
    }

    @Override
    public boolean onScroll(MotionEvent motionEvent, MotionEvent motionEvent2, float v, float v2) {
        controled.strafingX(v);
        controled.strafingY(v2);
        return true;
    }

    @Override
    public void onLongPress(MotionEvent motionEvent) {
        controled.zoomOut();
    }

    @Override
    public boolean onFling(MotionEvent motionEvent, MotionEvent motionEvent2, float v, float v2) {
        return true;
    }


    public boolean onTouch(View view, MotionEvent motionEvent) {
        detector.onTouchEvent(motionEvent);
        return true;
    }

    @Override
    public boolean onSingleTapConfirmed(MotionEvent motionEvent) {
        return false;
    }

    @Override
    public boolean onDoubleTap(MotionEvent motionEvent) {
        controled.reset();
        return true;
    }

    @Override
    public boolean onDoubleTapEvent(MotionEvent motionEvent) {
        return false;
    }
}
