package fr.unice.reneviergonin.demogestureav;

import android.app.Activity;
import android.content.Context;
import android.content.res.Configuration;
import android.graphics.Point;
import android.util.Log;
import android.view.Display;
import android.view.WindowManager;

import com.qualcomm.vuforia.CameraDevice;
import com.qualcomm.vuforia.Renderer;
import com.qualcomm.vuforia.State;
import com.qualcomm.vuforia.TrackableResult;
import com.qualcomm.vuforia.Vec2F;
import com.qualcomm.vuforia.Vec3F;
import com.qualcomm.vuforia.VideoMode;


public class NoRenderer { // implements GLSurfaceView.Renderer {


    private Activity mActivity;
    Point screenSize = new Point();

    public NoRenderer(Activity mActivity) {
        super();
        this.mActivity = mActivity;


        WindowManager wm = (WindowManager) mActivity.getSystemService(Context.WINDOW_SERVICE);
        Display display = wm.getDefaultDisplay();
        display.getSize(screenSize);
    }



    public Vec2F detect() {



        Renderer mRenderer = Renderer.getInstance();


        State state = mRenderer.begin();

        Vec2F onScreen = null;

        Log.d("PHILIPPE", "detect "+state.getNumTrackableResults() );


        // traitement d'une seule détection
        if (state.getNumTrackableResults() > 0) {
            TrackableResult result = state.getTrackableResult(0);

            Vec3F center = new Vec3F(0, 0, 0);
            Vec2F screenCenter = com.qualcomm.vuforia.Tool.projectPoint(CameraDevice.getInstance().getCameraCalibration(), result.getPose(), center);

            VideoMode videoMode = CameraDevice.getInstance().getVideoMode(CameraDevice.MODE.MODE_DEFAULT);

            int[] configPosition = {0,0};
            int[] configSize = {screenSize.x, screenSize.y};

            float xOffset = (screenSize.x - configSize[0]) / 2f + configPosition[0];
            float yOffset = (screenSize.y - configSize[1]) / 2f - configPosition[1];

            float[] screenCenterData = screenCenter.getData();

            if (mActivity.getResources().getConfiguration().orientation == Configuration.ORIENTATION_PORTRAIT) {
                float rotatedX = videoMode.getHeight() - screenCenterData[1];
                float rotatedY = screenCenterData[0];
                onScreen = new Vec2F(rotatedX * ((float) configSize[0]) / (float) videoMode.getHeight() + xOffset,
                        rotatedY * configSize[1] / (float) videoMode.getWidth() + yOffset);
            } else {
                onScreen = new Vec2F(screenCenterData[0] * configSize[0] / (float) videoMode.getWidth() + xOffset,
                        screenCenterData[1] * configSize[1] / (float) videoMode.getHeight() + yOffset);
            }
        }
        mRenderer.end();

        return onScreen;
    }
}
